<?php

/**
 * admin_cuenta actions.
 *
 * @package    canon
 * @subpackage admin_cuenta
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class admin_cuentaActions extends sfQuery {

    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * variables de filtro
             */

            $whereUsuario = ' ';
            $whereUsuario = " AND tab0.id_usuario = '" . $request['id_usuario'] . "' ";


            $wherePassword = ' ';
            if (isset($request['password'])) {
                $wherePassword = " AND tab0.password = '" . $request['password'] . "' ";
            }

            $whereNewUser = 'tab0.username = username';
            if (isset($request['user_nuevo'])) {
                $whereNewUser = " tab0.username = '" . $request['user_nuevo'] . "' ";
            }
            
            $whereDocumento = 'tab0.documento= documento';
            if (isset($request['documento'])) {
                $whereDocumento = " tab0.documento = '" . $request['documento'] . "' ";
            }
            
            $whereEmail = 'tab0.email = email';
            if (isset($request['email'])) {
                $whereEmail = " tab0.email = '" . $request['email'] . "' ";
            }
            
            $whereNombre = 'tab0.nombre = nombre ';
            if (isset($request['nombre'])) {
                $whereNombre = " tab0.nombre = '" . $request['nombre'] . "' ";
            }


            $whereNewPass = 'tab0.password = password ';
            if (isset($request['pass_nueva'])) {
                $whereNewPass = " tab0.password = '" . $request['pass_nueva'] . "' ";
            }


            if (isset($request['pass_nueva']) && isset($request['user_nuevo'])) {
                $whereNewUser = "tab0.password = '" . $request['pass_nueva'] . "', tab0.username = '" . $request['user_nuevo'] . "'";
                $whereNewPass = ' ';
            }

            $sql = <<<EOD

select count(*) as count from(
            
select * from ca_usuario tab0 where 1=1 $whereUsuario $wherePassword
            
)tabla

EOD;
            //ejecuta y obtiene el resultado del sql
            $records = CN_TABLE::executeSQL($sql);

            if ($records[0]["count"] != 0) {

                /*
                 * Obtiene las vigencias/periodo que se encuentre en la tabla de saldos
                 */
                $sql = <<<EOD

 UPDATE ca_usuario tab0 SET $whereNewUser, $whereNewPass, $whereDocumento, $whereEmail, $whereNombre  where 1=1 $whereUsuario

EOD;

                //ejecuta y obtiene el resultado del sql
                $records = CN_TABLE::executeSQL($sql);
                $this->status = 0;
                $this->startRow = $rowStart;
                $this->endRow = $rowEnd;
                $this->list_data = $records;
                $this->logMessage("[ADMIN-CUENTA] Consulta exitosa.");

                if ($rowStart == 0) {
                    //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                    $id_ope_bd = 1;
                    //obtener id maestro tabla
                    $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_usuario');
                    //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                    $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
                }
            } else {

                $this->status = 1;
                $this->mensajeError = "Error de autenticación";
                $this->list_data = array();
                $this->logMessage("[ADMIN-CUENTA] FAIL");
            }
        } catch (Exception $e) {

            $this->status = 1;
            $this->mensajeError = "[ADMIN-CUENTA] ERROR!!!";
            $this->list_data = array();
            $this->logMessage("[ADMIN-CUENTA] ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

// Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
